// Your phone's thickness
thickness = 10;

// Your phone's width
width = 85;

// Your phone's height
height = 162;

// Thickness of the shade's walls
wall_thickness = 0.9;

// How much of the shade to cut off from the bottom (in percentage)
bottom_cutoff = 30; //[0:100]

// How much of the shade to cut off at the top (in percentage)
top_cutoff = 20; //[0:70]

// Resolution of the round parts
$fn=30;

module phone() {
	hull() {
		translate([thickness/2, thickness/2, 0]) sphere(d=thickness);
		translate([width-thickness/2, height-thickness/2, 0]) sphere(d=thickness);
		translate([thickness/2, height-thickness/2, 0]) sphere(d=thickness);
		translate([width-thickness/2, thickness/2, 0]) sphere(d=thickness);
	}
}

difference() {
	radius = height*(100-bottom_cutoff)/100;
	bottom_offset = height*bottom_cutoff/100;
	top_offset = radius*(100-top_cutoff)/100;
	
	union() {
		minkowski() {
			phone();
			sphere(r=wall_thickness);
		}
		
		offset = 2;
		intersection() {
			translate([offset,offset,-thickness/2]) cube([width-(2*offset), height-(2*offset), height]);
			
			translate([0,height,0]) rotate([0,90,0]) cylinder(r=radius, h=width*2);
		}
	}
	offset2 = 2+(2*wall_thickness);
	translate([offset2,offset2-10,-thickness/2]) cube([width-(2*offset2), height-(2*offset2)+10, height+20]);
	translate([offset2+10,offset2-10-10,-thickness/2-20]) cube([width-(2*offset2)-20, height-(2*offset2)+10, height+20]);
	phone();
	
	// cutoffs
	if(bottom_cutoff > 0) {
		translate([-100,-100,-100]) cube([100+width+100,100+bottom_offset,100+height+100]);
	}
	translate([-100,-100,top_offset]) cube([100+height+width,100+height+width,height+width]);
	
	// button holes
	
	hole_radius = thickness/1.5;
	button_offset = ((-thickness+hole_radius)/2);
	for (i = [bottom_offset+thickness:thickness*2:height-thickness]) {
		hull() {
			translate([-100, i, button_offset]) rotate([0,90,0]) cylinder(d=hole_radius, h=width*2+100);
			translate([-100, i+(thickness/5*4), button_offset]) rotate([0,90,0]) cylinder(d=hole_radius, h=width*2+100);
		}
	}
	
	for(i=[-width/2.5:thickness*2:width/2.5]) {
		hull() {
			translate([width/2+i-wall_thickness, 0, button_offset]) rotate([-90,0,0]) cylinder(d=hole_radius, h=height*2+100);
			translate([width/2+i+thickness-wall_thickness, 0, button_offset]) rotate([-90,0,0]) cylinder(d=hole_radius, h=height*2+100);
		}
	}
}